{.po0}
{.pl71}
FUNCTION  upcase( c : Char ) : Char;
BEGIN
inline($3A/ c /        (*         LD    A,(c)       *)
    $FE/$61/           (*         CP    'a'         *)
    $DA/* + 12/        (*         JP    C,LOPPU     *)
    $FE/$7E/           (*        CP    '}' + 1      *)
    $D2/* + 7 /        (*         JP    NC,LOPPU    *)
    $D6/$20/           (*         SUB   20H         *)
    $32/ c );          (*         LD    (c),A       *)
                       (* LOPPU:  EQU  $            *)
  upcase := c
END;

FUNCTION charin(withecho: Boolean):Char; FORWARD;
PROCEDURE sendout(ch: Char);
(* Character output - bypasses word-wrap; also performs
 "pause" AND "abort" input character checks. *)
VAR temp: Char;
tctl: Boolean;
kuis: Byte;
BEGIN
kuis:=0;
IF NOT cancelled THEN
BEGIN
IF chBchr OR chAchr THEN
BEGIN
temp := charin(noecho);
IF (temp = pause) OR (upcase(temp) = 'S') THEN
BEGIN
tctl := controls;
controls := True;
temp := charin(noecho);
controls := tctl
END;
IF (temp = abort) OR (upcase(temp) = 'C') THEN cancelled := True
END;
xmitchar(ch);
conout(ch);
IF printon THEN Write(lst, ch);
IF (ch = cr) AND (lf = null) THEN Write(null);
END
END;

PROCEDURE flushbuff;

VAR
outpointer: byte;
BEGIN
 IF Length(buffer) > lastspace THEN
 FOR outpointer := lastspace + 1 TO Length(buffer) DO
 sendout(buffer[outpointer]);
 lastspace := Length(buffer)
 END;
PROCEDURE resetbuff;
BEGIN
 bufpointer := 0;
 lastspace := 0;
 charcount := 0;
 buffer := ''
END;
PROCEDURE charout(ch:Char);
VAR
 buffull   : Boolean;
 temp      : Byte;
 BEGIN
 IF caps THEN ch := upcase(ch);
 IF NOT (ch IN [null..^_]) THEN charcount := succ(charcount);
 IF (ch = bs) AND (charcount > 0) THEN charcount := charcount - 1;
 buffer := buffer + ch;
 bufpointer := Length(buffer);
 buffull := (charcount + 2 > width);
 IF buffull THEN BEGIN
 IF (lastspace > 0)
 THEN BEGIN
 buffer := Copy(buffer, lastspace + 1, bufpointer - lastspace);
 charcount := Length(buffer);
 lastspace := 0;
 END (* THEN *)
 ELSE BEGIN
 flushbuff;
 resetbuff;
 END; (* ELSE *)
 sendout(cr);
 sendout(lf);
 END; (* IF *)
 IF ch IN [null..space] THEN flushbuff;
 IF (ch=cr) THEN resetbuff;
END;

PROCEDURE stringout(message:line);

VAR
charpos: Integer;
BEGIN
FOR charpos := 1 TO Length(message) DO charout(message[charpos])
END;

PROCEDURE lineout; (* "FORWARD" declared in MACHDEP *)
Var temp:byte;
BEGIN
stringout(message);
charout(cr);
charout(lf);
END;

FUNCTION timedin: Boolean;
VAR times: Integer;
BEGIN
times := 0;
WHILE (times < 1000) AND NOT (chBchr or chAchr) DO BEGIN
times := times + 1;
delay(1)
END;
timedin := (chBchr OR chAchr) AND cts
END;
FUNCTION charin;    (* FORWARD m{{rittely tiedoston alussa. *)
VAR
ch: Char;
countime: Integer;
BEGIN
ch := null;
countime := 0;
REPEAT
IF timedin THEN (* Saatiin merkki joko modemilta tai konsolilta *)
IF chAchr THEN (* Saatiin konsolilta *)
ch := chAinp (* Luetaan alphatronic:n keskeytyspuskurista. *)
ELSE (* Saatiin modemilta *)
ch := chBinp (* Luetaan keskeytyspuskurista. *)
ELSE (* Ei merkki{ konsolilta eik{ modemilta *)
countime := countime + 1;
IF countime > 300 THEN
BEGIN
IF cts THEN
lineout(^M^J'PC-BBS:n aikavalvonta laukesi nyt !!! ');
hangup
END;
IF NOT cts THEN ch := cr;
IF (ch <> bs) AND NOT controls THEN ch := Chr(Ord(ch) AND 127)
UNTIL (ch IN [ abort, pause, bs, tab, cr, space..#127 ])
OR (controls AND (ch <> null));
IF (ch = #127) AND NOT controls THEN ch := bs;
IF ch = #$8D THEN ch := cr;
IF withecho THEN BEGIN
sendout(ch);
IF ch = bs THEN BEGIN sendout(' '); sendout(bs); END
END;
charin := ch
END;

PROCEDURE flush;
VAR
junk: Char;
BEGIN
WHILE chBchr DO junk := chBinp;
WHILE chAchr DO junk := chAinp;
clearstatus
END;

FUNCTION inputstring(withecho: Boolean): line;

VAR
temp:    line;
ch:      Char;
BEGIN
temp := '';
flush;
REPEAT
ch := charin(noecho);
IF (ch = bs) THEN BEGIN
IF Length(temp) > 0 THEN BEGIN
temp := Copy(temp, 1, Length(temp) - 1);
IF withecho THEN BEGIN
sendout(bs);
sendout(space);
sendout(bs)
END
END
END
ELSE BEGIN
IF (ch <> cr) AND (Length(temp) < 80)
AND ((ch IN [tab, space..#126]) OR controls) THEN BEGIN
IF ch = tab THEN REPEAT
temp := temp + space;
IF withecho THEN sendout(space)
UNTIL (Length(temp) mod 8) = 0
ELSE BEGIN
temp := temp + ch;
IF withecho THEN sendout(ch)
END (*ELSE*)
END
ELSE IF (ch <> cr) THEN sendout(bell)
END
UNTIL (ch = cr);
charout(cr); charout(lf);
inputstring := temp;
END;

FUNCTION getinput(prompt:line; maxlength:Integer; withecho:Boolean):line;
VAR posn: Integer;
temp: Char;
BEGIN
IF cancelled THEN BEGIN
cancelled := False;
lineout(space)
END;
IF inbuffer = '' THEN BEGIN
REPEAT
cancelled := False;
stringout(prompt);
IF bl = bell THEN stringout(bl)
UNTIL cancelled = False;
inbuffer := inputstring(withecho)
END;
IF maxlength = 1 THEN BEGIN
IF inbuffer = '' THEN temp := cr ELSE BEGIN
temp := inbuffer[1];
inbuffer := Copy(inbuffer, 2, Length(inbuffer)-1);
IF (Length(inbuffer) > 1) AND (inbuffer[1] = ';')
THEN inbuffer := Copy(inbuffer, 2, Length(inbuffer)-1);
END; (*ELSE*)
getinput := temp
END
ELSE BEGIN
posn := pos(';', inbuffer);
IF posn = 0 THEN posn := Length(inbuffer) + 1;
IF posn > maxlength THEN BEGIN
posn := maxlength + 1;
inbuffer := Copy(inbuffer, 1, maxlength)
END;
getinput := Copy(inbuffer, 1, posn - 1);
IF posn >= Length(inbuffer)
THEN inbuffer := ''
ELSE inbuffer := Copy(inbuffer, posn + 1, Length(inbuffer) - posn)
END
END;
FUNCTION allcaps(letters: person): person;
BEGIN
inline($21/letters/     (*     LD    HL,letters   *)
       $46/             (*     LD    B,(HL)       *)
       $04/             (*     INC   B            *)
       $05/             (* L1: DEC   B            *)
       $CA/* + 20/      (*     JP    Z,L2         *)
       $23/             (*     INC   HL           *)
       $7E/             (*     LD    A,(HL)       *)
       $FE/$61/         (*     CP    'a'          *)
       $DA/* - 9/       (*     JP    C,L1         *)
       $FE/$7E/         (*     CP    '}' + 1     *)
       $D2/* - 14/      (*     JP    NC,L1        *)
       $D6/$20/         (*     SUB   20H          *)
       $77/             (*     LD    (HL),A       *)
       $C3/* - 20);     (*     JP    L1           *)
                        (* L2: EQU   $            *)
allcaps := letters
END;
PROCEDURE set_thisdate;
Begin
clrscr;
dropRTS;
Write('Anna p{iv{m{{r{ (Muodossa: Pv/KK/Vuosi) : ');
readln(thisdate);
Write('Anna kellonaika:'^M'Tunnit  : ');
readln(hou);
Write('Minuutit: ');
readln(min);
Write('Sekunnit: ');
readln(sec);
END;
PROCEDURE awaitcall;
VAR
junk: Char;
oink: Byte;
BEGIN
if length(thisdate)<8 then set_thisdate;
Writeln(cr + lf + 'Odotan soittoa...');
flush;
REPEAT
Oink:=0;
Local:=False;
If keypressed then BEGIN
oink := bdos(6,$FF);
If oink=27 then local:=True;
If oink=133 then set_thisdate;
if oink=134 then writeln('Kello on '+timest);
END;
if Port[49]and 1=0 then BEGIN
local:=False;
oink:=27;
END;
CPU_Time;
Delay(3);
UNTIL oink=27;
clrscr;
BEGIN
IF local THEN
Writeln('Kontrolli on konsolilla...')
ELSE
Writeln('Kontrolli on modemilinjalla...');
delay(400);
flush;
junk := charin(noecho)
END
END;
PROCEDURE clearsc;
BEGIN
stringout(cs);
write(' ');
clrscr;
delay(100)   (* allows time FOR slow terminal screen clears *)
END;

FUNCTION getcap(prompt: line): Char;

  BEGIN
    getcap := upcase(getinput(prompt, 1, echo))
  END;

FUNCTION getint(nmax, star: Integer; prompt: line): Integer;

  VAR temp, test: Integer;
      outstr, userin: name;

  BEGIN
    Str(nmax:4, outstr);
    REPEAT
      temp := 0;
      userin := getinput(prompt, 4, echo);
      val(userin, temp, test);
      IF (test = 0) AND (temp > nmax) THEN
        lineout('NUMERO ON LIIAN SUURI: ' + outstr + ' on maksimiarvo. ')
    UNTIL ((test = 0) AND (temp >= 0) AND (temp <= nmax))
     OR (userin = '*') OR (userin = '') OR (userin = '?') OR NOT cts;
    IF userin = '' THEN getint := 0
     ELSE IF userin = '?' THEN getint := -1
      ELSE IF userin = '*' THEN getint := star
       ELSE getint := temp
  END;


PROCEDURE showtime;

  BEGIN
   lineout('P{iv{m{{r{ :   '+thisdate);
   lineout('Soittoaika :  '+copy(TimeON,length(TimeON)-8,length(TimeON)));
   lineout('Kello on   :   '+Timest);
  END;


PROCEDURE searchlib(infile: name; VAR result, libsects: Integer);

(* Library-file support adapted from DELIB.PAS
 by Bela Lubkin of Borland International. *)

  VAR
    temp: name;
    dirlength, offset, firstsec, loop, chrpos: Integer;

  BEGIN
    firstsec := 0; libsects := 0;
    blockread(libfile, libbuff, 1);
    IF libbuff[0] <> 0 THEN result := 1;
    loop := 1;
    WHILE (result = 0) AND (loop <= 11) DO BEGIN
      IF libbuff[loop] <> 32 THEN result := 1;
      loop := loop + 1;
    END;
    result := result + libbuff[12] + libbuff[13];
    IF result = 0 THEN BEGIN
      dirlength := libbuff[14] + 256*libbuff[15];
      IF dirlength = 0 THEN result := 1;
    END;
    IF result = 0 THEN BEGIN
      loop := 0;
      WHILE (loop < 4*dirlength-1) AND (result = 0) AND (firstsec = 0) DO BEGIN
        loop := loop + 1;
        offset := 32*(loop mod 4);
        IF offset = 0 THEN blockread(libfile, libbuff, 1);
        IF libbuff[offset] <> 0 THEN result := 1
        ELSE BEGIN
          temp := '';
          FOR chrpos := 1 TO 8 DO
            IF libbuff[offset + chrpos] <> 32 THEN
              temp := temp + Chr(libbuff[offset + chrpos]);
          IF libbuff[offset + 9] <> 32 THEN BEGIN
            temp := temp + '.';
            FOR chrpos := 9 TO 11 DO
              IF libbuff[offset + chrpos] <> 32 THEN
                temp := temp + Chr(libbuff[offset + chrpos]);
          END;
          IF cts AND (infile = 'DIR') THEN lineout(temp);
          IF infile = temp THEN BEGIN
            firstsec := libbuff[offset+12] + 256*libbuff[offset+13];
            libsects := libbuff[offset+14] + 256*libbuff[offset+15];
            Seek(libfile, firstsec)
          END
        END
      END;
      IF infile = 'DIR' THEN result := 0
    END
  END;

PROCEDURE libassign(filename: longname; VAR result: Integer);

  VAR
    infile: name;
    slash: Integer;
    library: Boolean;

  BEGIN
    result := 0;
    slash := pos('/', filename);
    library := (slash > 0);
    IF library THEN BEGIN
      infile := Copy(filename, slash + 1, Length(filename) - slash);
      filename := Copy(filename, 1, slash - 1);
      IF pos('.', filename) = 0 THEN filename := filename + '.LBR'
    END;
    Assign(libfile, filename);
    {$I-} Reset(libfile) {$I+};
    result := IOresult;
    IF result = 0 THEN
      IF library THEN searchlib(infile, result, libsects)
      ELSE libsects := Filesize(libfile);
    libeof := (libsects = 0)
  END;

PROCEDURE libblockread(VAR fileblock: filbuffer);

  BEGIN
    IF libsects > 0 THEN blockread(libfile, fileblock, 1);
    libsects := libsects - 1;
    IF libsects = 0 THEN libeof := True;
  END;

PROCEDURE typefile(fname: longname; nowrap: Boolean);

(* Inline unsqueezer adapted from USQ.PAS V1.3, which
 was written by Scott Loftesness, adapted FOR Turbo
 Pascal by Steve Freeman AND made compatible WITH
 Non-Turbo Pascal squeezers by myself.- BM *)

  CONST
    recognize  = $FF76;
    numvals    = 257;      (* max tree size + 1 *)
    speof      = 256;      (* special END of file marker *)
    dle: Char  = #$90;

  TYPE
    tree       = ARRAY [0..255,0..1] OF Integer;

  VAR
    in_ptr, result: Integer;
    in_buff: filbuffer;
    dnode: tree;
    inchar, curin, filecksum, bpos, i, repct, numnodes: Integer;
    c, lastchar: Char;
    origfile: name;
    squeezed, eofin: Boolean;
    r:byte;

  FUNCTION getc: Integer;

    BEGIN
      in_ptr := in_ptr + 1;
      IF in_ptr > 127 THEN BEGIN
        IF libeof THEN eofin := True
        ELSE BEGIN
          libblockread(in_buff);
          in_ptr := 0
        END
      END;
      IF eofin THEN getc := 26 ELSE getc := in_buff[in_ptr]
    END;

  FUNCTION getw: Integer;

    VAR in1,in2: Integer;

    BEGIN
      in1 := getc; in2 := getc;
      getw := in1 + in2 shl 8
    END;

  PROCEDURE initialize;

    VAR str: string[14];

    BEGIN
      in_ptr := 127; squeezed := True;
      repct:=0;   bpos:=99;   origfile:='';   eofin:=False;
      i := getw;
      IF (recognize <> i) THEN BEGIN
        squeezed := False;
        in_ptr := -1;
      END
      ELSE BEGIN
        filecksum := getw;     (* get checksum from chars 2 - 3 of file *)
        REPEAT    (* build original file name *)
          inchar:=getc;
          IF inchar <> 0
            THEN origfile := origfile + Chr(inchar)
        UNTIL inchar = 0;
        lineout('Alkuper{inen tiedosto: ' + origfile);
        numnodes:=Ord(getw); (* get the number of nodes in this files tree *)
        IF (numnodes<0) OR (numnodes>=numvals) THEN BEGIN
          squeezed := False;
          in_ptr := -1
        END
      END;
      IF squeezed THEN BEGIN
        dnode[0,0]:= -(speof+1);
        dnode[0,1]:= -(speof+1);
        numnodes:=numnodes-1;
        FOR i:=0 TO numnodes DO BEGIN
          dnode[i,0]:=getw;
          dnode[i,1]:=getw
        END
      END
    END;

  FUNCTION getuhuff: Char;

    VAR i: Integer;
        r: Byte;
    BEGIN
      i:=0;
      REPEAT
        bpos:=bpos+1;
        IF bpos>7 THEN BEGIN
          curin := getc;
          bpos:=0;
        END
        ELSE curin := curin shr 1;
        i := Ord(dnode[i,Ord(curin AND $0001)]);
      UNTIL (i<0);
      i := -(i+1);
      IF i=speof THEN BEGIN
        eofin:=True;
        getuhuff:=Chr(26);
      END
      ELSE getuhuff:=Chr(i);
    END;

  FUNCTION getcr: Char;

    VAR c: Char;

    BEGIN
      IF squeezed THEN BEGIN
        IF (repct>0) THEN BEGIN
          repct:=repct-1;
          getcr:=lastchar
        END
        ELSE BEGIN
          c:=getuhuff;
          IF c<>dle THEN BEGIN
            getcr:=c;
            lastchar:=c
          END
          ELSE BEGIN
            repct:=Ord(getuhuff);
            IF repct=0 THEN getcr:=dle
            ELSE BEGIN
              repct:=repct-2;
              getcr:=lastchar
            END
          END
        END
      END
      ELSE getcr := Chr(getc)
    END; (*getcr*)

  BEGIN
    libassign(fname, result);
    IF result <> 0 THEN lineout('En l|yd{: ' + fname + '!')
    ELSE
     BEGIN
      initialize;
      WHILE cts AND NOT(cancelled OR eofin) DO
       BEGIN
        c:=getcr;
        IF c = #26 THEN eofin := True
        ELSE
         BEGIN
          IF nowrap THEN
           BEGIN
            IF c <> #$8D THEN
            BEGIN (* <-- Allows no-wrap using WordStar files *)
              c := Chr(Ord(c) AND 127);
              IF (c <> lnfd) THEN charout(c);
              IF c = cr THEN charout(lf);

            END
           END
          ELSE
           sendout(c);
         END
       END;
      Close(libfile)
     END
  END;

PROCEDURE outfile(fname: longname);

  BEGIN
    typefile(fname, True)
  END;

FUNCTION findid(caller: person): Integer;

  VAR
    usernum: Integer;
    index: Integer;

  BEGIN
    usernum := 0;
    index := 0;
    IF caller <> '***' THEN
     lineout('Etsin k{ytt{j{listasta... ');
    {$I-} Reset(idfile) {$I+};
    IF IOresult <> 0 THEN Rewrite(idfile);
    WHILE (usernum = 0) AND NOT eof(idfile) DO BEGIN
      index := index + 1;
      read(idfile, idrec);
      IF idrec.user = caller THEN usernum := index
    END;
    findid := usernum
  END;

PROCEDURE getcomments(maxline: Integer);

  VAR
    comfile: FILE OF line;
    linenum: Integer;
    head, temp: line;

  BEGIN
    Str(maxline:1, temp);
    lineout('--->  Kirjoita kommenttisi. Korkeintaan ' + temp + ' rivi{.' +
            ' Anna tyhj{ rivi,');
    lineout('      kun lopetat. ');
    lineout(space);
    linenum := 0;
    Assign(comfile, 'COMMENTS.BBS');
    {$I-} Reset(comfile) {$I+};
    IF IOresult <> 0 THEN Rewrite(comfile);
    Seek(comfile, Filesize(comfile));
    head := caller;
    head := head + '  ' + timeon;
    REPEAT
      linenum := linenum + 1;
      Str(linenum:2, temp);
      stringout(temp + ': ');
      temp := inputstring(echo);
      IF temp <> '' THEN
       BEGIN
        IF linenum = 1 THEN Write(comfile, head);
        Write(comfile, temp)
       END
    UNTIL (temp = '') OR (linenum = maxline) OR NOT cts;
    Close(comfile)
  END;

FUNCTION nextuser: Integer;

  VAR temp: Integer;

  BEGIN
    lineout('Etsin tilaa uudelle k{ytt{j{lle...');
    temp := findid('***');
    IF temp = 0 THEN nextuser := 1 + Filesize(idfile) ELSE nextuser := temp
  END;

PROCEDURE savedefaults;

  BEGIN
    WITH idrec DO BEGIN
      user := caller;
      IF expert THEN exfl := 0 ELSE exfl := 255;
      lsto := timeon+'  Klo: '+Timest;
      lstm := nextmess;
      pass := password;
      clr := cs;
      acc := access;
      bsp := bs;
      lnf := lf;
      upc := caps;
      wid := width;
    END;
    Seek(idfile, usernum - 1);
    Write(idfile, idrec)
  END;

PROCEDURE disconnect;

  VAR
    ch: Char;

  BEGIN
    clearsc;
    IF NOT expert THEN
     lineout('Vastaamalla kysymykseen muuten kuin K tai E palaat posti'+
             'laatikkoon: ');
    ch := getcap('Haluatko j{tt{{ kommentteja SYSOP:lle (K/E) ? ');
    IF ch = 'K' THEN getcomments(15);
    IF (ch = 'E') OR (ch = 'K') OR NOT cts THEN
     BEGIN
      IF cts THEN
       lineout('Kiitos soitostasi, ' + caller + '.');
      savedefaults;
      hangup
     END
  END;
  savedefaults;
      hangup
     END
  END;
